// HttpSocket.cpp: implementation of the CHttpSocket class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HttpSocket.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define MAXHEADERSIZE 1024
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CHttpSocket::CHttpSocket()
{
	m_s=NULL;
	m_phostent=NULL;
	m_port=80;

	m_bConnected=FALSE;

	for(int i=0;i<256;i++)
		m_ipaddr[i]='\0';
	memset(m_requestheader,0,MAXHEADERSIZE);
	memset(m_ResponseHeader,0,MAXHEADERSIZE);

	m_nCurIndex = 0;		//
	m_bResponsed = FALSE;
	m_nResponseHeaderSize = -1;
/*
	m_nBufferSize = nBufferSize;
	m_pBuffer = new char[nBufferSize];
	memset(m_pBuffer,0,nBufferSize);*/
}

CHttpSocket::~CHttpSocket()
{
	CloseSocket();
}

BOOL CHttpSocket::Socket()
{
	if(m_bConnected)return FALSE;

	struct protoent *ppe; 
	ppe=getprotobyname("tcp"); 
	
	///SOCKET
	m_s=socket(PF_INET,SOCK_STREAM,ppe->p_proto);
	if(m_s==INVALID_SOCKET)
	{
		//MessageBox(NULL,"ʼʧ!","",MB_OK);
		return FALSE;
	}

	return TRUE;

}

BOOL CHttpSocket::Connect(char *szHostName,int nPort)
{
	if(szHostName==NULL)
		return FALSE;

	///Ѿ,ȹر
	if(m_bConnected)
	{
		CloseSocket();
	}

	///˿ں
	m_port=nPort;

	///IPַ
	m_phostent=gethostbyname(szHostName);
	if(m_phostent==NULL)
	{
		//MessageBox(NULL,"ʧ!","",MB_OK);
		return FALSE;
	}
	
	///
	struct in_addr ip_addr;
	memcpy(&ip_addr,m_phostent->h_addr_list[0],4);///h_addr_list[0]4ֽ,ÿֽ8λ
	
	struct sockaddr_in destaddr;
	memset((void *)&destaddr,0,sizeof(destaddr)); 
	destaddr.sin_family=AF_INET;
	destaddr.sin_port=htons(nPort);
	destaddr.sin_addr=ip_addr;

	///IPַַ
	sprintf(m_ipaddr,"%d.%d.%d.%d",
		destaddr.sin_addr.S_un.S_un_b.s_b1,
		destaddr.sin_addr.S_un.S_un_b.s_b2,
		destaddr.sin_addr.S_un.S_un_b.s_b3,
		destaddr.sin_addr.S_un.S_un_b.s_b4);
	/*inet_addr();ѴIPַַתΪin_addrʽ;
	  inet_ntoa();෴*/
	
	/*עsturct in_addr Ľṹ:һ32λ;һͬʽʹ
	(1)ÿ8λһs_b1~s_b4;
	(2)ÿ16λһs_w1~s_w2;
	(3)32λs_addr
	struct   in_addr {
    union   {
			  struct{
				unsigned  char   s_b1,
								 s_b2,
								 s_b3,
								 s_b4;
					} S_un_b;
              struct{
				unsigned  short  s_w1,
                                 s_w2
			        }S_un_w;      
               unsigned long  S_addr;
			} S_un;
		};
	*/

	if(connect(m_s,(struct sockaddr*)&destaddr,sizeof(destaddr))!=0)
	{
		//CloseSocket();
		//m_s=NULL;
		//MessageBox(NULL,"ӷʧ!","",MB_OK);
		return FALSE;
	}

	///Ѿӵı־
	m_bConnected=TRUE;
	return TRUE;
}

///URLHTTPͷ
const char *CHttpSocket::FormatRequestHeader(char *pServer,char *pObject, long &Length,
									  char *pCookie,char *pReferer,long nFrom,
									  long nTo,int nServerType)
{
	char szPort[10];
	char szTemp[20];
	sprintf(szPort,"%d",m_port);
	memset(m_requestheader,'\0',1024);

	///1:,·,汾
	strcat(m_requestheader,"GET ");
	strcat(m_requestheader,pObject);
	strcat(m_requestheader," HTTP/1.1");
    strcat(m_requestheader,"\r\n");

	///2:
    strcat(m_requestheader,"Host:");
	strcat(m_requestheader,pServer);
    strcat(m_requestheader,"\r\n");

	///3:
	if(pReferer != NULL)
	{
		strcat(m_requestheader,"Referer:");
		strcat(m_requestheader,pReferer);
		strcat(m_requestheader,"\r\n");		
	}

	///4:յ
    strcat(m_requestheader,"Accept:*/*");
    strcat(m_requestheader,"\r\n");

	///5:
    strcat(m_requestheader,"User-Agent:Mozilla/4.0 (compatible; MSIE 5.00; Windows 98)");
    strcat(m_requestheader,"\r\n");

	///6:,
	strcat(m_requestheader,"Connection:Keep-Alive");
	strcat(m_requestheader,"\r\n");

	///7:Cookie.
	if(pCookie != NULL)
	{
		strcat(m_requestheader,"Set Cookie:0");
		strcat(m_requestheader,pCookie);
		strcat(m_requestheader,"\r\n");
	}

	///8:ʼֽλ(ϵĹؼ)
	if(nFrom > 0)
	{
		strcat(m_requestheader,"Range: bytes=");
		_ltoa(nFrom,szTemp,10);
		strcat(m_requestheader,szTemp);
		strcat(m_requestheader,"-");
		if(nTo > nFrom)
		{
			_ltoa(nTo,szTemp,10);
			strcat(m_requestheader,szTemp);
		}
		strcat(m_requestheader,"\r\n");
	}
	
	///һ:
	strcat(m_requestheader,"\r\n");

	///ؽ
	Length=strlen(m_requestheader);
	return m_requestheader;
}

///ͷ
BOOL CHttpSocket::SendRequest(const char *pRequestHeader, long Length)
{
	if(!m_bConnected)return FALSE;

	if(pRequestHeader==NULL)
		pRequestHeader=m_requestheader;
	if(Length==0)
		Length=strlen(m_requestheader);

	if(send(m_s,pRequestHeader,Length,0)==SOCKET_ERROR)
	{
		//MessageBox(NULL,"ʧ!","",MB_OK);
		return FALSE;
	}
	int nLength;
	GetResponseHeader(nLength);
	return TRUE;
}

long CHttpSocket::Receive(char* pBuffer,long nMaxLength)
{
	if(!m_bConnected)return NULL;

	///
	long nLength;
	nLength=recv(m_s,pBuffer,nMaxLength,0);
	
	if(nLength <= 0)
	{
		//MessageBox(NULL,"recv()ִʧ!","",MB_OK);
		CloseSocket();
	}
	return nLength;
}

///ر׽
BOOL CHttpSocket::CloseSocket()
{
	if(m_s != NULL)
	{
		if(closesocket(m_s)==SOCKET_ERROR)
		{
			//MessageBox(NULL,"closesocket()ִʧ!","",MB_OK);
			return FALSE;
		}
	}
	m_s = NULL;
	m_bConnected=FALSE;
	return TRUE;
}

int CHttpSocket::GetRequestHeader(char *pHeader, int nMaxLength) const
{
	int nLength;
	if(int(strlen(m_requestheader))>nMaxLength)
	{
		nLength=nMaxLength;
	}
	else
	{
		nLength=strlen(m_requestheader);
	}
	memcpy(pHeader,m_requestheader,nLength);
	return nLength;
}

//ýջ߷͵ʱ
BOOL CHttpSocket::SetTimeout(int nTime, int nType)
{
	if(nType == 0)
	{
		nType = SO_RCVTIMEO;
	}
	else
	{
		nType = SO_SNDTIMEO;
	}

	DWORD dwErr;
    dwErr=setsockopt(m_s,SOL_SOCKET,nType,(char*)&nTime,sizeof(nTime)); 
	if(dwErr)
	{
		//MessageBox(NULL,"setsockopt()ִʧ!","",MB_OK);
		return FALSE;
	}
	return TRUE;
}

//ȡHTTPķͷ
const char* CHttpSocket::GetResponseHeader(int &nLength)
{
	if(!m_bResponsed)
	{
		char c = 0;
		int nIndex = 0;
		BOOL bEndResponse = FALSE;
		while(!bEndResponse && nIndex < MAXHEADERSIZE)
		{
			recv(m_s,&c,1,0);
			m_ResponseHeader[nIndex++] = c;
			if(nIndex >= 4)
			{
				if(m_ResponseHeader[nIndex - 4] == '\r' && m_ResponseHeader[nIndex - 3] == '\n'
					&& m_ResponseHeader[nIndex - 2] == '\r' && m_ResponseHeader[nIndex - 1] == '\n')
				bEndResponse = TRUE;
			}
		}
		m_nResponseHeaderSize = nIndex;
		m_bResponsed = TRUE;
	}
	
	nLength = m_nResponseHeaderSize;
	return m_ResponseHeader;
}

//HTTPӦͷеһ.
int CHttpSocket::GetResponseLine(char *pLine, int nMaxLength)
{
	if(m_nCurIndex >= m_nResponseHeaderSize)
	{
		m_nCurIndex = 0;
		return -1;
	}

	int nIndex = 0;
	char c = 0;
	do 
	{
		c = m_ResponseHeader[m_nCurIndex++];
		pLine[nIndex++] = c;
	} while(c != '\n' && m_nCurIndex < m_nResponseHeaderSize && nIndex < nMaxLength);
	
	return nIndex;
}

int CHttpSocket::GetField(const char *szSession, char *szValue, int nMaxLength)
{
	//ȡĳֵ
	if(!m_bResponsed) return -1;
	
	CString strRespons;
	strRespons = m_ResponseHeader;
	int nPos = -1;
	nPos = strRespons.Find(szSession,0);
	if(nPos != -1)
	{
		nPos += strlen(szSession);
		nPos += 2;
		int nCr = strRespons.Find("\r\n",nPos);
		CString strValue = strRespons.Mid(nPos,nCr - nPos);
		strcpy(szValue,strValue);
		return (nCr - nPos);
	}
	else
	{
		return -1;
	}
}

int CHttpSocket::GetServerState()
{
	//ûȡӦͷ,ʧ
	if(!m_bResponsed) return -1;
	
	char szState[3];
	szState[0] = m_ResponseHeader[9];
	szState[1] = m_ResponseHeader[10];
	szState[2] = m_ResponseHeader[11];

	return atoi(szState);
}






//base64
static void EncodeBase64(unsigned char *out, const unsigned char *in, int inlen)
{
	const char base64digits[] =
		"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	for (; inlen >= 3; inlen -= 3)
	{
		*out++ = base64digits[in[0] >> 2];
		*out++ = base64digits[((in[0] << 4) & 0x30) | (in[1] >> 4)];
		*out++ = base64digits[((in[1] << 2) & 0x3c) | (in[2] >> 6)];
		*out++ = base64digits[in[2] & 0x3f];
		in += 3;
	}
	if (inlen > 0)
	{
		unsigned char fragment;
		
		*out++ = base64digits[in[0] >> 2];
		fragment = (in[0] << 4) & 0x30;
		if (inlen > 1)
			fragment |= in[1] >> 4;
		*out++ = base64digits[fragment];
		*out++ = (inlen < 2) ? '=' : base64digits[(in[1] << 2) & 0x3c];
		*out++ = '=';
	}
	*out = '\0';
};

//Ӵ
//lpszDesHost:Ŀ
//nDestPort:Ŀ˿ں
//lpszProxyAddress:
//nProxyPort:˿ں
//lpszProxyProtocol:Э"HTTP""SOCKS5"
//bNeedAuthǷҪ֤
//lpszUserName:û
//lpszPassword:

BOOL CHttpSocket::ConnectProxy(const char *lpszDestHost, int nDestPort, const char * lpszProxyAddress, const int nProxyPort, const char * lpszProxyProtocol, BOOL bNeedAuth, const char * lpszUserName, const char * lpszPassword)
{
	if(lpszDestHost==NULL)
		return FALSE;

	///Ѿ,ȹر
	if(m_bConnected)
	{
		CloseSocket();
	}

	///˿ں
	m_port=nDestPort;

	///IPַ
	m_phostent=gethostbyname(lpszDestHost);
	if(m_phostent==NULL)
	{
		//MessageBox(NULL,"ʧ!","",MB_OK);
		return FALSE;
	}

	

	
	char szBuffer[1024 + 1] = {""};
	int nLen = 0;	
	
	SOCKADDR_IN saProxy;
	saProxy.sin_family = AF_INET;
	saProxy.sin_port = htons(nProxyPort);
	saProxy.sin_addr.S_un.S_addr= inet_addr(lpszProxyAddress);
	if (saProxy.sin_addr.S_un.S_addr == INADDR_NONE)
	{
		LPHOSTENT lphost;
		lphost = gethostbyname(lpszProxyAddress);
		if (lphost != NULL)
			saProxy.sin_addr.S_un.S_addr = ((LPIN_ADDR)lphost->h_addr)->s_addr;
		else
		{
			return 0;
		}
	} 
	
	if(connect(m_s, (SOCKADDR*)&saProxy, sizeof(SOCKADDR)))
	{
		return 0;
	}
	
	if(stricmp(lpszProxyProtocol, "HTTPS") == 0 || stricmp(lpszProxyProtocol, "HTTP") == 0 )
	{
		if(bNeedAuth)
		{
			//Proxy-Authorization: Basic 
			char szAuth[1024 + 1] = {""};
			char szAuthT[1024 + 1] = {""};
			sprintf(szAuthT, "%s:%s", lpszUserName,lpszPassword);
			EncodeBase64((UCHAR *)szAuth, (UCHAR *)szAuthT, strlen(szAuthT));
			sprintf(szBuffer, "CONNECT %s:%d HTTP/1.0\r\nProxy-Authorization: Basic %s\r\n\r\n", lpszDestHost, nDestPort, szAuth);
		}
		else
		{
			sprintf(szBuffer, "CONNECT %s:%d HTTP/1.0\r\n\r\n", lpszDestHost, nDestPort);
		}
		
		nLen = strlen(szBuffer);
		send(m_s, szBuffer, nLen, 0);
		nLen = 1024;
		recv(m_s, szBuffer, nLen, 0);
		if(strnicmp(szBuffer, "HTTP/1.0 200", strlen("HTTP/1.0 200")) == 0 || 
			strnicmp(szBuffer, "HTTP/1.1 200", strlen("HTTP/1.1 200")) == 0)
		{
			//Ѿӵı־
			m_bConnected=TRUE;
			return 1;
		}
		return 0;
	}
	
	if(stricmp(lpszProxyProtocol, "SOCKS5") == 0)
	{
		//auth
		nLen = 0;
		if(bNeedAuth)
		{
			szBuffer[0] = 5;
			szBuffer[1] = 2;
			szBuffer[2] = 0;
			szBuffer[3] = 2;
			nLen = 4;
			send(m_s, szBuffer, nLen, 0);
			nLen = 2;
			recv(m_s, szBuffer, nLen, 0);
			if(szBuffer[0] == 5)
			{
				//need auth
				if(szBuffer[1] == 2)
				{
					szBuffer[0] = 1;
					nLen = strlen(lpszUserName);
					szBuffer[1] = nLen;
					strcpy(szBuffer+2, lpszUserName);
					nLen += 2;
					szBuffer[nLen] = strlen(lpszPassword);
					strcpy(szBuffer+nLen+1, lpszPassword);
					nLen = nLen + 1 + strlen(lpszPassword);
					send(m_s, szBuffer, nLen, 0);
					nLen = 2;
					recv(m_s, szBuffer, nLen, 0);
					if(szBuffer[1] != 0)
					{
						return 0;
					}
				}
				else
				{
					if(szBuffer[1] != 0)
					{
						return 0;
					}
				}
			}
			else
				return 0;
			
		}
		else
		{
			szBuffer[0] = 5;
			szBuffer[1] = 1;
			szBuffer[2] = 0;
			nLen = 3;
			send(m_s, szBuffer, nLen, 0);
			nLen = 2;
			recv(m_s, szBuffer, nLen, 0);
			if(szBuffer[0] != 5 || szBuffer[1] != 0)
			{
				return 0;
			}
		}
		//translate DestAddr
		szBuffer[0] = 5;
		szBuffer[1] = 1;
		szBuffer[2] = 0;
		szBuffer[3] = 3;//DOMAIN
		szBuffer[4] = strlen(lpszDestHost);//domain len
		strcpy(szBuffer+5, lpszDestHost);
		unsigned short uPort = htons(nDestPort);
		memcpy(szBuffer+5+strlen(lpszDestHost), &uPort, 2);
		nLen = 5 + strlen(lpszDestHost) + 2;
		send(m_s, szBuffer, nLen, 0);
		nLen = 10;
		recv(m_s, szBuffer, nLen, 0);
		if(szBuffer[0] != 5 || szBuffer[1] != 0)
		{
			return 0;
		}
		//Ѿӵı־
		m_bConnected=TRUE;
		return 1;
	}
	return 0;
}

